Index: cards/delphes_card_HLLHC.tcl
===================================================================
--- cards/delphes_card_HLLHC.tcl	(revision 08fe3d27c2ad18101eb9472e7616224428b879be)
+++ cards/delphes_card_HLLHC.tcl	(revision 8a58fff8046971d4b88c9d20358af1ccf51852f5)
@@ -14,4 +14,9 @@
 
   ParticlePropagator
+  TrackMergerProp
+
+  DenseProp
+  DenseMergeTracks
+  DenseTrackFilter
 
   ChargedHadronTrackingEfficiency
@@ -23,7 +28,4 @@
   MuonMomentumSmearing
 
-  DenseProp
-  DenseMergeTracks
-  TrackMergerProp  
   TrackMerger
 
@@ -71,7 +73,7 @@
 
 
-#################################
-# Propagate particles in cylinder
-#################################
+#####################################
+# Track propagation to calorimeters
+#####################################
 
 module ParticlePropagator ParticlePropagator {
@@ -92,4 +94,85 @@
 }
 
+##############
+# Track merger
+##############
+
+module Merger TrackMergerProp {
+# add InputArray InputArray
+  add InputArray ParticlePropagator/chargedHadrons
+  add InputArray ParticlePropagator/electrons
+  add InputArray ParticlePropagator/muons
+  set OutputArray tracks
+}
+
+####################################
+# Track propagation to pseudo-pixel
+####################################
+
+module ParticlePropagator DenseProp {
+
+  set InputArray TrackMergerProp/tracks
+
+  # radius of the magnetic field coverage, in m
+  set Radius 0.3
+  set RadiusMax 1.2
+  # half-length of the magnetic field coverage, in m
+  set HalfLength 0.7
+  set HalfLengthMax 3.25
+
+  # magnetic field
+  set Bz 3.0
+}
+
+#####################
+# Dense Track merger
+#####################
+
+module Merger DenseMergeTracks {
+# add InputArray InputArray
+  add InputArray DenseProp/chargedHadrons
+  add InputArray DenseProp/electrons
+  add InputArray DenseProp/muons
+  set OutputArray tracks
+}
+
+
+######################
+#   Dense Track Filter
+######################
+
+module DenseTrackFilter DenseTrackFilter {
+
+  set TrackInputArray DenseMergeTracks/tracks
+
+  set TrackOutputArray tracks
+  set ChargedHadronOutputArray chargedHadrons
+  set ElectronOutputArray electrons
+  set MuonOutputArray muons
+
+  set EtaPhiRes 0.003
+  set EtaMax 4.0
+
+  set pi [expr {acos(-1)}]
+
+  set nbins_phi [expr {$pi/$EtaPhiRes} ]
+  set nbins_phi [expr {int($nbins_phi)} ]
+
+  set PhiBins {}
+  for {set i -$nbins_phi} {$i <= $nbins_phi} {incr i} {
+    add PhiBins [expr {$i * $pi/$nbins_phi}]
+  }
+
+  set nbins_eta [expr {$EtaMax/$EtaPhiRes} ]
+  set nbins_eta [expr {int($nbins_eta)} ]
+
+  for {set i -$nbins_eta} {$i <= $nbins_eta} {incr i} {
+    set eta [expr {$i * $EtaPhiRes}]
+    add EtaPhiBins $eta $PhiBins
+  }
+}
+
+
+
 ####################################
 # Charged hadron tracking efficiency
@@ -97,5 +180,5 @@
 
 module Efficiency ChargedHadronTrackingEfficiency {
-  set InputArray ParticlePropagator/chargedHadrons
+  set InputArray DenseTrackFilter/chargedHadrons
   set OutputArray chargedHadrons
 
@@ -122,5 +205,5 @@
 
 module Efficiency ElectronTrackingEfficiency {
-  set InputArray ParticlePropagator/electrons
+  set InputArray DenseTrackFilter/electrons
   set OutputArray electrons
 
@@ -145,5 +228,5 @@
 
 module Efficiency MuonTrackingEfficiency {
-  set InputArray ParticlePropagator/muons
+  set InputArray DenseTrackFilter/muons
   set OutputArray muons
 
@@ -443,9 +526,11 @@
 }
 
+
+
 ##############
 # Track merger
 ##############
 
-module Merger TrackMergerProp {
+module Merger TrackMerger {
 # add InputArray InputArray
   add InputArray ChargedHadronMomentumSmearing/chargedHadrons
@@ -453,75 +538,4 @@
   add InputArray MuonMomentumSmearing/muons
   set OutputArray tracks
-}
-
-
-#################################
-# Dense Track propagation
-#################################
-
-module ParticlePropagator DenseProp {
-  set InputArray Delphes/stableParticles
-
-  set OutputArray stableParticles
-  set NeutralOutputArray neutralParticles
-  set ChargedHadronOutputArray chargedHadrons
-  set ElectronOutputArray electrons
-  set MuonOutputArray muons
-
-  # radius of the magnetic field coverage, in m
-  set Radius 0.3
-  set RadiusMax 1.2
-  # half-length of the magnetic field coverage, in m
-  set HalfLength 0.7
-  set HalfLengthMax 3.25
-
-  # magnetic field
-  set Bz 3.0
-}
-
-
-####################
-# Dense Track merger
-###################
-
-module Merger DenseMergeTracks {
-# add InputArray InputArray
-  add InputArray DenseProp/chargedHadrons
-  add InputArray DenseProp/electrons
-  add InputArray DenseProp/muons
-  set OutputArray tracks
-}
-
-
-######################
-#   Dense Track Filter
-######################
-
-module DenseTrackFilter TrackMerger {
-  set TrackInputArray TrackMergerProp/tracks
-  set DenseChargedInputArray DenseMergeTracks/tracks
-
-  set TrackOutputArray tracks
-
-  set EtaPhiRes 0.003
-  set EtaMax 4.0
-
-  set pi [expr {acos(-1)}]
-
-  set nbins_phi [expr {$pi/$EtaPhiRes} ]
-  set nbins_phi [expr {int($nbins_phi)} ]
-
-  set PhiBins {}
-  for {set i -$nbins_phi} {$i <= $nbins_phi} {incr i} {
-    add PhiBins [expr {$i * $pi/$nbins_phi}]
-  }
-
-  set nbins_eta [expr {$EtaMax/$EtaPhiRes} ]
-  set nbins_eta [expr {int($nbins_eta)} ]
-
-  for {set i -$nbins_eta} {$i <= $nbins_eta} {incr i} {
-    set eta [expr {$i * $EtaPhiRes}]
-    add EtaPhiBins $eta $PhiBins
-  }
 }
 
